# TODO:
# - mpi support
# - inter-library linking (if possible at all - cross-dependencies?)
Summary:	The Massively Parallel Quantum Chemistry Program
Summary(pl.UTF-8):	Program do równoległych obliczeń z zakresu chemii kwantowej
Name:		mpqc
Version:	2.3.1
Release:	9
License:	LGPL/GPL (see LICENSE)
Group:		Libraries
Source0:	http://downloads.sourceforge.net/mpqc/%{name}-%{version}.tar.bz2
# Source0-md5:	2f9b4f7487387730d78066a53764f848
Patch0:		%{name}-paths.patch
Patch1:		%{name}-libfl.patch
Patch2:		format-security.patch
Patch3:		cxx11.patch
URL:		http://www.mpqc.org/
# -lsB_BLAS ?
# cca-chem-config (http://www.cca-forum.org/~cca-chem/)
# niama-config ??? not found by google
# -lessl is preferred over -lblas? (then -lf77blas -latlas)
BuildRequires:	autoconf
BuildRequires:	blas-devel
BuildRequires:	gcc-fortran
BuildRequires:	lapack-devel
BuildRequires:	libint-devel
BuildRequires:	libstdc++-devel
BuildRequires:	perl-base
BuildRequires:	sed >= 4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_check_so	1

%description
MPQC is the Massively Parallel Quantum Chemistry Program. It computes
properties of atoms and molecules from first principles using the time
independent Schroedinger equation. It runs on a wide range of
architectures ranging from individual workstations to symmetric
multiprocessors to massively parallel computers. Its design is object
oriented, using the C++ programming language.

%description -l en.UTF-8
MPQC is the Massively Parallel Quantum Chemistry Program. It computes
properties of atoms and molecules from first principles using the time
independent Schrödinger equation. It runs on a wide range of
architectures ranging from individual workstations to symmetric
multiprocessors to massively parallel computers. Its design is object
oriented, using the C++ programming language.

%description -l pl.UTF-8
MPQC (Massively Parallel Quantum Chemistry Program) to program do
równoległych obliczeń z zakresu chemii kwantowej. Oblicza właściwości
atomów i cząsteczek z pierwszych zasad przy użyciu niezależnego od
czasu równania Schrödingera. Działa na wielu architekturach od
osobistych stacji roboczych poprzez maszyny wieloprocesorowe SMP do
komputerów do obliczeń równoległych. Jest zaprojektowany w sposób
zorientowany obiektowo przy użyciu języka C++.

%package devel
Summary:	Header files for MPQC library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki MPQC
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	blas-devel
# XXX: should be libgfortran-devel
Requires:	gcc-fortran
Requires:	lapack-devel
Requires:	libint-devel
Requires:	libstdc++-devel

%description devel
Header files for MPQC library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki MPQC.

%package static
Summary:	Static MPQC library
Summary(pl.UTF-8):	Statyczna biblioteka MPQC
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static MPQC library.

%description static -l pl.UTF-8
Statyczna biblioteka MPQC.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%{__sed} -i -e '1s,/usr/bin/env perl,%{__perl},' src/bin/mpqc/{ccarun,mpqcrun}.in

%build
%{__autoconf}
%configure \
	--enable-shared \
	--with-cc-optflags="%{rpmcflags}" \
	--with-cxx-optflags="%{rpmcxxflags} -std=c++11" \
	--with-flibs="-lgfortran" \
	--with-sc-includedir=%{_includedir}/mpqc
# --enable-components (requires cca-chem-config)
%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install install_devel \
	installroot=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGES CITATION LICENSE README
%attr(755,root,root) %{_bindir}/ccarun
%attr(755,root,root) %{_bindir}/chkmpqcout
%attr(755,root,root) %{_bindir}/molrender
%attr(755,root,root) %{_bindir}/mpqc
%attr(755,root,root) %{_bindir}/mpqcrun
%attr(755,root,root) %{_bindir}/scls
%attr(755,root,root) %{_bindir}/scpr
%attr(755,root,root) %{_bindir}/tkmolrender
%attr(755,root,root) %{_libdir}/libSC*.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libSC*.so.7
%attr(755,root,root) %{_libdir}/libmpqc.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmpqc.so.7
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/%{version}
%{_datadir}/%{name}/%{version}/basis
%{_datadir}/%{name}/%{version}/elisp
%{_datadir}/%{name}/%{version}/perl
%attr(755,root,root) %{_datadir}/%{name}/%{version}/ccarunproc
%attr(755,root,root) %{_datadir}/%{name}/%{version}/mpqcrunproc
%{_datadir}/%{name}/%{version}/atominfo.kv
# XXX: add to system file database?
%{_datadir}/%{name}/%{version}/magic

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/sc-config
%attr(755,root,root) %{_bindir}/sc-libtool
%attr(755,root,root) %{_bindir}/sc-mkf77sym
%attr(755,root,root) %{_libdir}/libSC*.so
%attr(755,root,root) %{_libdir}/libmpqc.so
%{_libdir}/libSC*.la
%{_libdir}/libmpqc.la
%{_includedir}/mpqc

%files static
%defattr(644,root,root,755)
%{_libdir}/libSC*.a
%{_libdir}/libmpqc.a
%changelog
* Fri Jul 27 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mpqc.git;a=log;h=master

* Fri Jul 27 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 3cb7e7a
- release 9 (by relup.sh)

* Wed Aug 16 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 3c5b4e8
- release 8 (by relup.sh)

* Sun May 28 2017 Jakub Bogusz <qboosh@pld-linux.org> c8f77d8
- release 7 (rebuild with libint 1.2.x)

* Sat May 27 2017 Jakub Bogusz <qboosh@pld-linux.org> 2838419
- c++11 patch requires compiling in C++ 11 mode

* Thu May 25 2017 Jan Rękorajski <baggins@pld-linux.org> 6e370dc
- fix sprintf abuse
- fix c++11 compile error
- rel 6

* Thu May 25 2017 Jan Rękorajski <baggins@pld-linux.org> 5d61af3
- rebuild with lapack 3.7
- release 5 (by relup.sh)

* Sun Jan 09 2011 Jakub Bogusz <qboosh@pld-linux.org> a4450d1
- package ghost soname symlinks

* Thu Feb 25 2010 sparky <sparky@pld-linux.org> ee8627a
- added paths and libfl patches
- autoconf (no other autotools used)
- rel 4

* Thu Feb 25 2010 sparky <sparky@pld-linux.org> 277b07f
- remove libfl check, it probably reffers to some "lib float", but for us
  it ix flex library, which is obviously wrong

* Thu Feb 25 2010 sparky <sparky@pld-linux.org> 2366ab7
- fix sc libdir path

* Sat Jul 05 2008 Michał 'Wolvverine' Panasiewicz <wolvverine@pld-linux.org> 31f994a
- rel.2

* Sun Oct 21 2007 Michał 'Wolvverine' Panasiewicz <wolvverine@pld-linux.org> 9142b90
- rel.2

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 299fc99
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 2b8e6a8
- converted to UTF-8

* Sun Jul 23 2006 Jakub Bogusz <qboosh@pld-linux.org> 8241306
- pass --with-flibs to avoid linking with libgfortranbegin

* Sun Jul 23 2006 Jakub Bogusz <qboosh@pld-linux.org> dba1ecd
- new

